//
//      ScrollBarControl.cpp
//
//      This source code was automatically
//      generated by SophiaFramework 4.0.
//

#include "ScrollBarControl.hpp"

#define BAR_WIDTH 7

// boot loader
SFCApplet::FactorySPP SFCApplet::Boot(AEECLSID id, SFXAnsiStringPtr license)
{
    *license = "";

    return (id == AEECLSID_SCROLLBARCONTROL) ? (&ScrollBarControl::Factory) : (null);
}

// factory function
SFCInvokerPtr ScrollBarControl::Factory(Void)
{
    return ::new ScrollBarControl;
}

// constructor
ScrollBarControl::ScrollBarControl(Void) static_throws
{
    SFZWindowSmp                        window;
    SFZTextButtonControlSmp             button1;
    SFZTextButtonControlSmp             button2;
    SFZTextButtonControlSmp             button3;
    SFZContainerScrollBarControlSmp     bar;
    SFXRectangle                        rx;
    SFCError                            error(SFERR_NO_ERROR);

    // create window, which will be binded with scroll bar
    window = SFZWindow::NewInstance(&error);

    window->SetParent(GetThis());
    window->SetBackgroundColor(SFXRGBColor(0xDD, 0xFF, 0xDD, 0x00));

    // set window's real region: size (200, 150) 
    window->SetRealBound(SFXRectangle(20, 50, 200, 150));

    // set window's virtual region: size (200, 550)
    window->SetVirtualBound(SFXRectangle(window->GetRealBound()).SetOrigin(0, 0).AddBottom(400));

    window->SetState(true, true, true, true);


    // create button1
    button1 = SFZTextButtonControl::NewInstance(&error);
    button1->SetParent(window);
    button1->SetText("button1");

    // offset coordinate from window's point of view: (50, 50)
    button1->SetRealBound(button1->GetSuitableBound().SetOrigin(50, 50));

    button1->SetState(true, true, true, true);


    // create button2
    button2 = SFZTextButtonControl::NewInstance(&error);
    button2->SetParent(window);
    button2->SetText("button2");

    // offset coordinate from window's point of view: (50, 100)
    button2->SetRealBound(button2->GetSuitableBound().SetOrigin(50, 100));

    button2->SetState(true, true, true, false);


    // create button3
    button3 = SFZTextButtonControl::NewInstance(&error);
    button3->SetParent(window);
    button3->SetText("button3");

    // offset coordinate from window's point of view: (50, 500)
    button3->SetRealBound(button3->GetSuitableBound().SetOrigin(50, 500));
    button3->SetState(true, true, true, false);


    // create instance of scroll bar control
    bar = SFZContainerScrollBarControl::NewInstance(&error);

    bar->SetParent(GetThis());

    // set vertical scroll bar
    bar->SetOrientation(SFZContainerScrollBarControl::VERTICAL);

    // place scroll bar control on right side to window
    rx = window->GetRealBound();
    bar->SetRealBound(SFXRectangle(rx.GetRight(), rx.GetTop(), BAR_WIDTH, rx.GetHeight()));

    bar->SetState(true, true, false, false);

    // bind window with scroll bar control
    bar->Bind(window);
}

// destructor
ScrollBarControl::~ScrollBarControl(Void)
{
}
